/*
 * This file is part of the Nepomuk KDE project.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

/*
 * This file has been generated by the Nepomuk Resource class generator.
 * DO NOT EDIT THIS FILE.
 * ANY CHANGES WILL BE LOST.
 */

#ifndef _HISTORYITEM_H_
#define _HISTORYITEM_H_

class QDateTime;
class QDate;
class QTime;

namespace Nepomuk2 {

}

#include <Nepomuk2/Resource>


namespace Nepomuk2 {

    /**
     * A kget history item. 
     */
    class  HistoryItem : public Resource
    {
    public:
        /**
         * Create a new empty and invalid HistoryItem instance
         */
        HistoryItem();

        /**
         * Default copy constructor
         */
        HistoryItem( const HistoryItem& );
        HistoryItem( const Resource& );

        /**
         * Create a new HistoryItem instance representing the resource
         * referenced by \a uriOrIdentifier.
         */
        HistoryItem( const QString& uriOrIdentifier );

        /**
         * Create a new HistoryItem instance representing the resource
         * referenced by \a uri.
         */
        HistoryItem( const QUrl& uri );
        ~HistoryItem();

        HistoryItem& operator=( const HistoryItem& );

        /**
         * Get property 'destination'. Destination of the download. 
         */
        QString destination() const;

        /**
         * Set property 'destination'. Destination of the download. 
         */
        void setDestination( const QString& value );

        /**
         * \return The URI of the property 'destination'. 
         */
        static QUrl destinationUri();

        /**
         * Get property 'source'. Source of the download. 
         */
        QString source() const;

        /**
         * Set property 'source'. Source of the download. 
         */
        void setSource( const QString& value );

        /**
         * \return The URI of the property 'source'. 
         */
        static QUrl sourceUri();

        /**
         * Get property 'state'. State of the download. 
         */
        qint32 state() const;

        /**
         * Set property 'state'. State of the download. 
         */
        void setState( const qint32& value );

        /**
         * \return The URI of the property 'state'. 
         */
        static QUrl stateUri();

        /**
         * Get property 'size'. Size of the download. 
         */
        qint32 size() const;

        /**
         * Set property 'size'. Size of the download. 
         */
        void setSize( const qint32& value );

        /**
         * \return The URI of the property 'size'. 
         */
        static QUrl sizeUri();

        /**
         * Get property 'dateTime'. DateTime of the download. 
         */
        QDateTime dateTime() const;

        /**
         * Set property 'dateTime'. DateTime of the download. 
         */
        void setDateTime( const QDateTime& value );

        /**
         * \return The URI of the property 'dateTime'. 
         */
        static QUrl dateTimeUri();



        /**
         * \return The URI of the resource type that is used in HistoryItem instances.
         */
        static QString resourceTypeUri();

    protected:
       HistoryItem( const QString& uri, const QUrl& type );
       HistoryItem( const QUrl& uri, const QUrl& type );
    };
}

#endif
